\definecolor{grey}{RGB}{158, 158, 158}
\definecolor{vert}{RGB}{174, 234, 0}
\definecolor{violet}{RGB}{233, 30, 99}
\definecolor{indigo}{RGB}{63, 81, 181}


\begin{figure*}
	\centering

	\subfloat[Throughput]{ % Default behavior.
		\begin{tikzpicture}
			\begin{axis}[ymin = 0, width = .3\textwidth, error bars/y dir = both, xlabel = Time (seconds), ylabel = Transactions per second, legend style = {font = \tiny, at = {(0.5,-0.35)}, anchor = north, legend columns = -1}]
				\addplot[grey] table [x = time, y = transactions_avg, y error = transactions_std, col sep = semicolon]{CSV/default/transactions_A.csv};
				\addlegendentry{A}
				\addplot[grey, dotted] table [x = time, y = transactions_avg, y error = transactions_std, col sep = semicolon]{CSV/default/transactions_B.csv};
				\addlegendentry{B}
				\addplot[vert] coordinates {(0, 800) (1080, 800)};
				\addlegendentry{High offered load}
				\addplot[black] coordinates {(0, 200) (1080, 200)};
				\addlegendentry{Low offered load}
			\end{axis}
		\end{tikzpicture}

		\label{fig_transactions}
	}
	\subfloat[Physical memory footprint]{
		\begin{tikzpicture}
			\begin{axis}[ymin = 0, width = .3\textwidth, error bars/y dir = both, xlabel = Time (seconds), ylabel = Memory (bytes), legend style = {font = \tiny, at = {(0.5,-0.35)}, anchor = north, legend columns = -1}]
				\addplot[grey] table [x = iteration, y = usage_avg, y error = usage_std, col sep = semicolon]{CSV/default/stats_A.csv};
				\addlegendentry{A}
				\addplot[grey, dotted] table [x = iteration, y = usage_avg, y error = usage_std, col sep = semicolon]{CSV/default/stats_B.csv};
				\addlegendentry{B}
				\addplot[vert] coordinates {(0, 2.8 * 10^9) (1080, 2.8 * 10^9)};
				\addlegendentry{Reference}
			\end{axis}
		\end{tikzpicture}

		\label{fig_memory}
	}

	\caption{\footnotesize No limits set}
	\label{fig_default}

	\subfloat[Throughput]{ % Max limit behavior.
		\begin{tikzpicture}
			\begin{axis}[ymin = 0, width = .3\textwidth, error bars/y dir = both, xlabel = Time (seconds), ylabel = Transactions per second, legend style = {font = \tiny, at = {(0.5,-0.35)}, anchor = north, legend columns = -1}]
				\addplot[grey] table [x = time, y = transactions_avg, y error = transactions_std, col sep = semicolon]{CSV/max/transactions_A.csv};
				\addplot[grey, dotted] table [x = time, y = transactions_avg, y error = transactions_std, col sep = semicolon]{CSV/max/transactions_B.csv};
				\addplot[vert] coordinates {(0, 800) (1080, 800)};
				\addplot[black] coordinates {(0, 200) (1080, 200)};
			\end{axis}
		\end{tikzpicture}

		\label{fig_transactions_max}
	}
	\subfloat[Physical memory footprint]{
		\begin{tikzpicture}
			\begin{axis}[ymin = 0, width = .3\textwidth, error bars/y dir = both, xlabel = Time (seconds), ylabel = Memory (bytes), legend style = {font = \tiny, at = {(0.5,-0.35)}, anchor = north, legend columns = -1}]
				\addplot[indigo] coordinates {(0, 18 * 10^8) (1080, 18 * 10^8)};
				\addlegendentry{A's \texttt{max} limit}
				\addplot[indigo, dotted] coordinates {(0, 10^9) (1080, 10^9)};
				\addlegendentry{B's \texttt{max} limit}
				\addplot[grey] table [x = iteration, y = usage_avg, y error = usage_std, col sep = semicolon]{CSV/max/stats_A.csv};
				\addplot[grey, dotted] table [x = iteration, y = usage_avg, y error = usage_std, col sep = semicolon]{CSV/max/stats_B.csv};
				\addplot[vert] coordinates {(0, 2.8 * 10^9) (1080, 2.8 * 10^9)};
			\end{axis}
		\end{tikzpicture}

		\label{fig_memory_max}
	}

	\caption{\footnotesize \texttt{Max} limits set to \SI{1.8}{\giga\byte} (A) and \SI{1}{\giga\byte} (B)}
	\label{fig_max}

	\subfloat[Throughput]{ % Soft limit behavior.
		\begin{tikzpicture}
			\begin{axis}[ymin = 0, width = .3\textwidth, error bars/y dir = both, xlabel = Time (seconds), ylabel = Transactions per second, legend style = {font = \tiny, at = {(0.5,-0.35)}, anchor = north, legend columns = -1}]
				\addplot[grey] table [x = time, y = transactions_avg, y error = transactions_std, col sep = semicolon]{CSV/soft/transactions_A.csv};
				\addplot[grey, dotted] table [x = time, y = transactions_avg, y error = transactions_std, col sep = semicolon]{CSV/soft/transactions_B.csv};
				\addplot[vert] coordinates {(0, 800) (1080, 800)};
				\addplot[black] coordinates {(0, 200) (1080, 200)};
			\end{axis}
		\end{tikzpicture}

		\label{fig_transactions_soft}
	}
	\subfloat[Physical memory footprint]{
		\begin{tikzpicture}
			\begin{axis}[ymin = 0, width = .3\textwidth, error bars/y dir = both, xlabel = Time (seconds), ylabel = Memory (bytes), legend style = {font = \tiny, at = {(0.5,-0.35)}, anchor = north, legend columns = -1}]
				\addplot[violet] coordinates {(0, 18 * 10^8) (1080, 18 * 10^8)};
				\addlegendentry{A's \texttt{soft} limit}
				\addplot[violet, dotted] coordinates {(0, 10^9) (1080, 10^9)};
				\addlegendentry{B's \texttt{soft} limit}
				\addplot[grey] table [x = iteration, y = usage_avg, y error = usage_std, col sep = semicolon]{CSV/soft/stats_A.csv};
				\addplot[grey, dotted] table [x = iteration, y = usage_avg, y error = usage_std, col sep = semicolon]{CSV/soft/stats_B.csv};
				\addplot[vert] coordinates {(0, 2.8 * 10^9) (1080, 2.8 * 10^9)};
			\end{axis}
		\end{tikzpicture}

		\label{fig_memory_soft}
	}

	\caption{\footnotesize \texttt{Soft} limits set to \SI{1.8}{\giga\byte} (A) and \SI{1}{\giga\byte} (B)}
	\label{fig_soft}
\end{figure*}